import 'dart:async';

import 'package:yona/src/addr.dart';
import 'package:yona/src/msg.dart';
import 'package:yona/src/peer.dart';
import 'package:yona_crypto/crypto.dart';

class Printer implements Handlers {
  @override
  Future<void> onError<T>(T error, [StackTrace? trace]) async {
    print(error);
    print(trace);
  }

  @override
  Future<void> onMsg(Msg msg) async {
    print(msg.data);
  }
}

void main() async {
  var node = Node(Printer(),
      sk: genSK(),
      webrokers: [NetAddr.fromString("yonafediverse.com:2222")],
      name: "ali",
      verival: NetAddr.fromString("yonafediverse.com:3333"),
      webinbox: NetAddr.fromString("yonafediverse.com:4444"));
  await node.publish();
  Timer.run(() async {
    await node.listenWebinbox();
  });
  Timer.run(() async {
    await node.listenWebroker();
  });
  Timer.periodic(Duration(milliseconds: 2000), (timer) async {
    await node.send(genMsgID(), timer.tick.toString(), node);
  });
}
