class NetAddr {
  final int port;
  final String host;

  NetAddr(this.port, this.host);

  @override
  String toString() {
    return "$host:$port";
  }

  Uri toUri(String? scheme) {
    return Uri(scheme: scheme, host: host, port: port);
  }

  static NetAddr fromString(String addr) {
    var parts = addr.split(':');
    if (parts.length != 2) {
      throw Exception("invalid net address $addr");
    }
    return NetAddr(int.parse(parts[1]), parts[0]);
  }
}
